functor MkPackedParenMatchG (structure Seq : SEQUENCE)
  :> PACKED_PAREN_MATCH_G where type 'a seq = 'a Seq.t =
struct
  type 'a seq = 'a Seq.t

  fun parenMatch (g : int) (parens : Paren.Pack.t Seq.t) : bool =
    if g < 1 then raise Fail "granularity must be at least 1" else
    let
      fun serialpm parens =
        let
          fun extendParen ((i,j), p) =
            case p of
              Paren.L => (i, j+1)
            | Paren.R => if j = 0 then (i+1, j) else (i, j-1)

          fun extendPack ((i,j), ps) =
            Paren.Pack.iterate extendParen (i,j) ps
        in
          Seq.iterate extendPack (0,0) parens
        end

      fun pm parens =
        if Seq.length parens <= g then serialpm parens else
        let val Seq.PAIR (A, B) = Seq.splitMid parens
            val ((i, j), (k, l)) = Primitives.par (fn () => pm A, fn () => pm B)
        in if j <= k then (i + k - j, l) else (i, l + j - k)
        end
    in
      pm parens = (0, 0)
    end
end
