functor MkParenMatch (structure Seq : SEQUENCE)
  :> PAREN_MATCH where type 'a seq = 'a Seq.t =
struct
  type 'a seq = 'a Seq.t

  fun parenMatch (parens : Paren.t Seq.t) : bool =
    let
      fun parenMatch' parens =
        case Seq.splitMid parens of
          Seq.EMPTY => (0, 0)
        | Seq.ONE Paren.L => (0, 1)
        | Seq.ONE Paren.R => (1, 0)
        | Seq.PAIR (A, B) =>
            let val ((i, j), (k, l)) =
                  Primitives.par (fn () => parenMatch' A,
                                  fn () => parenMatch' B)
            in if j <= k then (i + k - j, l) else (i, l + j - k)
            end
    in
      parenMatch' parens = (0, 0)
    end
end
